/****************************************************************************
 * Header for X hints.
 * Copyright (C) 2004 Joe Wingbermuehle
 ****************************************************************************/

#ifndef PROT_H
#define PROT_H

/* The Basics */
extern Atom protWMState;
extern Atom protWMProtocols;
extern Atom protWMDeleteWindow;
extern Atom protWMTakeFocus;
extern Atom protWMLocaleName;
extern Atom protWMCommand;
extern Atom protWMChangeState;

/* WM Spec */
extern Atom protNetSupported;
extern Atom protNetNumberOfDesktops;
extern Atom protNetDesktopGeometry;
extern Atom protNetDesktopViewport;
extern Atom protNetCurrentDesktop;
extern Atom protNetDesktopNames;
extern Atom protNetActiveWindow;
extern Atom protNetWorkarea;
extern Atom protNetSupportingWMCheck;
extern Atom protNetWMDesktop;
extern Atom protNetWMState;
extern Atom protNetWMStateSticky;
extern Atom protNetWMName;
extern Atom protNetWMIcon;

/* GNOME Hints */
extern Atom protWinLayer;
extern Atom protWinState;
extern Atom protWinWorkspace;
extern Atom protWinWorkspaceCount;
extern Atom protWinSupportingWMCheck;
extern Atom protWinProtocols;

/* MWM Hints */
#ifdef USE_MWM_HINTS
extern Atom protMWMHints;
#endif

void InitializeProtocols();
void ReadCurrentDesktop();

void ReadClientProtocols(ClientNode *np);

void ReadWMName(ClientNode *np);
void ReadWMNormalHints(ClientNode *np);
void ReadWMProtocols(ClientNode *np);

void ReadNetWMDesktop(ClientNode *np);

void ReadWinLayer(ClientNode *np);

int GetCardinalAtom(Window window, Atom atom, CARD32 *value);
int GetWindowAtom(Window window, Atom atom, Window *value);

void SetCardinalAtom(Window window, Atom atom, CARD32 value);
void SetWindowAtom(Window window, Atom atom, CARD32 value);

#endif

